// SimpleWorkerThreadProgressBarDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SimpleWorkerThreadProgressBar.h"
#include "SimpleWorkerThreadProgressBarDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// worker thread
typedef struct THREADINFOSTRUCT {
	HWND hWnd;
} THREADINFOSTRUCT;
UINT WorkerThreadProc( LPVOID lParam );


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSimpleWorkerThreadProgressBarDlg dialog




CSimpleWorkerThreadProgressBarDlg::CSimpleWorkerThreadProgressBarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimpleWorkerThreadProgressBarDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSimpleWorkerThreadProgressBarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROGRESS1, m_ctrlProgress);
}

BEGIN_MESSAGE_MAP(CSimpleWorkerThreadProgressBarDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &CSimpleWorkerThreadProgressBarDlg::OnBnClickedStart)
	ON_MESSAGE(WM_USER_THREAD_FINISHED, OnThreadFinished)
	ON_MESSAGE(WM_USER_THREAD_UPDATE_PROGRESS, OnThreadUpdateProgress)
END_MESSAGE_MAP()


// CSimpleWorkerThreadProgressBarDlg message handlers

BOOL CSimpleWorkerThreadProgressBarDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	// Initialize the progress control
	m_ctrlProgress.SetRange32( 0, 100 );
	m_ctrlProgress.SetStep( 1 );
	m_ctrlProgress.SetPos( 0 );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSimpleWorkerThreadProgressBarDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSimpleWorkerThreadProgressBarDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSimpleWorkerThreadProgressBarDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSimpleWorkerThreadProgressBarDlg::OnBnClickedStart()
{
	// TODO: Add your control notification handler code here
	THREADINFOSTRUCT * tis=new THREADINFOSTRUCT;
	tis->hWnd = m_hWnd;

	CWinThread *pThread = AfxBeginThread(WorkerThreadProc,tis,THREAD_PRIORITY_NORMAL,0,0,NULL);
	AfxMessageBox("Thread Started");
}

LRESULT CSimpleWorkerThreadProgressBarDlg::OnThreadFinished(WPARAM wParam,LPARAM lParam)
{
	AfxMessageBox("Thread has exited");
	return 0;
}

LRESULT CSimpleWorkerThreadProgressBarDlg::OnThreadUpdateProgress(WPARAM wParam,LPARAM lParam)
{
	m_ctrlProgress.SetPos(100*(int)wParam/(int)lParam);
	return 0;
}

UINT WorkerThreadProc( LPVOID lParam )
{
	THREADINFOSTRUCT* tis=(THREADINFOSTRUCT*)lParam;
	for (int i=0;i<100;i++) {
		PostMessage(tis->hWnd,WM_USER_THREAD_UPDATE_PROGRESS,i,100);
		Sleep(100);
	}
	PostMessage(tis->hWnd,WM_USER_THREAD_FINISHED,0,0);
	delete tis;
	return 0;
}
